//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaMaracasVisuwxPopupMenu.h"
#include "bbcreaMaracasVisuPackage.h"

#include <wx/menu.h>
#include <wx/kbdstate.h>

namespace bbcreaMaracasVisu
{

PopupMenuInteractor::PopupMenuInteractor( wxPopupMenu *box , wxVtkBaseView *wxvtkbaseview )
{
    _wxvtkbaseview  = wxvtkbaseview;
    _box            = box;
}

PopupMenuInteractor::~PopupMenuInteractor()
{
}

void PopupMenuInteractor::OnPopupClick(wxCommandEvent &evt)
{
//    void *data=static_cast<wxMenu *>(evt.GetEventObject())->GetClientData();
//    switch( evt.GetId()) {
//        case ID_SOMETHING:
//            break;
//        case ID_SOMETHING_ELSE:
//            break;
//    }
    int id=evt.GetId()-1000;
    _box->bbSetOutputOut( id );
    std::vector<std::string>    lstItems    = _box->bbGetInputIn();
    int                         size        = lstItems.size();
    if ((id>=0) && (id<size))
    {
        _box->bbSetOutputSimpleText( lstItems[id] );
    } else {
        _box->bbSetOutputSimpleText( "void" );
    }
    _box->bbSetOutputPoint( _lstPoint );
    _box->bbSignalOutputModification();
}

bool PopupMenuInteractor::OnRightButtonUp()
{
    if (_wxvtkbaseview!=NULL)
    {
        wxWindow                    *window     = _wxvtkbaseview->GetWxVTKRenderWindowInteractor();
        const wxPoint               pt          = wxGetMousePosition();
        int                         xWindow     = pt.x - window->GetScreenPosition().x;
        int                         yWindow     = pt.y - window->GetScreenPosition().y;
        std::vector<std::string>    lstItems    = _box->bbGetInputIn();
        int                         size        = lstItems.size();
        int                         i;
        wxMenu                      menu;

        /*
        int X,Y,Z;
        crea::wxVTKRenderWindowInteractor *wxVTKiren;
        wxVTKiren = _vtkInteractorStyleBaseView->GetWxVtk2DBaseView()->GetWxVTKRenderWindowInteractor();
        wxVTKiren->GetEventPosition(X,Y);
        Z = (int)((wxVtk2DBaseView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView()))->GetVtkBaseData()->GetZ();
        double dxx     = X;
        double dyy     = Y;
        double dzz     = Z;
        _vtkInteractorStyleBaseView->GetWxVtk2DBaseView()->TransFromCoordScreenToWorld(dxx,dyy,dzz,true);
        _px    = (int)(dxx+0.5);
        _py    = (int)(dyy+0.5);
        _pz    = (int)(dzz+0.0);
        */
        int x,y,z;
        ((wxVtk2DBaseView*)(_vtkInteractorStyleBaseView->GetWxVtk2DBaseView()))->GetVtkBaseData()->GetPointMouse(x,y,z);
        _lstPoint.clear();
        _lstPoint.push_back(x);
        _lstPoint.push_back(y);
        _lstPoint.push_back(z);

        int systelCtrlKey = _wxvtkbaseview->GetInteractorStyleBaseView()->GetInteractor()->GetControlKey();
        
        bool ok=false;

        if  ((_withCtrlKey==true) && (systelCtrlKey==1))
        {
            ok=true;
        }
        if  ((_withCtrlKey==false) && (systelCtrlKey==0))
        {
            ok=true;
        }

        ok=ok && GetActive();
            
        if  (ok==true)
        {
            
            for (i=0;i<size;i++)
            {
                wxString itemString( lstItems[i].c_str() , wxConvUTF8 );
                wxMenuItem *item = menu.Append(i+1000, itemString  );
            } // for
            menu.Connect( wxEVT_COMMAND_MENU_SELECTED, (wxObjectEventFunction) (wxCommandEventFunction) &PopupMenuInteractor::OnPopupClick,NULL,this );
            window->PopupMenu(&menu,xWindow,yWindow);
       } // if ControlKey
        
     } // if _vtkbaseview
}

void    PopupMenuInteractor::SetWithCtrlKey(bool flag)
{
    _withCtrlKey=flag;
}


BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,wxPopupMenu)
BBTK_BLACK_BOX_IMPLEMENTATION(wxPopupMenu,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxPopupMenu::Process()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
    
    if (firsttime==true)
    {
        firsttime=false;
        if (bbGetInputwxVtkBaseView()!=NULL)
        {
            popupmenuinteractor                = new PopupMenuInteractor( this, bbGetInputwxVtkBaseView()  );
            popupmenuinteractor->SetWithCtrlKey( bbGetInputWithCtrlKey() );
            vtkInteractorStyleBaseView *vtkinteractorstylebaseview  = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView()->GetInteractorStyleBaseView() );
            vtkinteractorstylebaseview->AddInteractorStyleMaracas( popupmenuinteractor );
        } // if wxVtkBaseView
        
        if (bbGetInputwxVtkBaseView2()!=NULL)
        {
            popupmenuinteractor2               = new PopupMenuInteractor( this, bbGetInputwxVtkBaseView2()  );
            popupmenuinteractor2->SetWithCtrlKey( bbGetInputWithCtrlKey() );
            vtkInteractorStyleBaseView *vtkinteractorstylebaseview  = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView2()->GetInteractorStyleBaseView() );
            vtkinteractorstylebaseview->AddInteractorStyleMaracas( popupmenuinteractor2 );
        } // if wxVtkBaseView2

        if (bbGetInputwxVtkBaseView3()!=NULL)
        {
            popupmenuinteractor3               = new PopupMenuInteractor( this, bbGetInputwxVtkBaseView3()  );
            popupmenuinteractor3->SetWithCtrlKey( bbGetInputWithCtrlKey() );
            vtkInteractorStyleBaseView *vtkinteractorstylebaseview  = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView3()->GetInteractorStyleBaseView() );
            vtkinteractorstylebaseview->AddInteractorStyleMaracas( popupmenuinteractor3 );
        } // if wxVtkBaseView3

        if (bbGetInputwxVtkBaseView4()!=NULL)
        {
            popupmenuinteractor4                = new PopupMenuInteractor( this, bbGetInputwxVtkBaseView4()  );
            popupmenuinteractor4->SetWithCtrlKey( bbGetInputWithCtrlKey() );
            vtkInteractorStyleBaseView *vtkinteractorstylebaseview  = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView4()->GetInteractorStyleBaseView() );
            vtkinteractorstylebaseview->AddInteractorStyleMaracas( popupmenuinteractor4 );
        } // if wxVtkBaseView4
        
        
        bbSetOutputInteractorStyleMaracas(  (InteractorStyleMaracas*)popupmenuinteractor  );
        bbSetOutputInteractorStyleMaracas2( (InteractorStyleMaracas*)popupmenuinteractor2 );
        bbSetOutputInteractorStyleMaracas3( (InteractorStyleMaracas*)popupmenuinteractor3 );
        bbSetOutputInteractorStyleMaracas4( (InteractorStyleMaracas*)popupmenuinteractor4 );

    } // if firsttime
    
    if (popupmenuinteractor !=NULL) { popupmenuinteractor ->SetActive(  bbGetInputActive() ); }
    if (popupmenuinteractor2!=NULL) { popupmenuinteractor2->SetActive(  bbGetInputActive() ); }
    if (popupmenuinteractor3!=NULL) { popupmenuinteractor3->SetActive(  bbGetInputActive() ); }
    if (popupmenuinteractor4!=NULL) { popupmenuinteractor4->SetActive(  bbGetInputActive() ); }

    bbSetOutputOut(-1);
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxPopupMenu::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
    firsttime = true;
    bbSetInputActive(true);
    bbSetInputwxVtkBaseView(NULL);
    bbSetInputwxVtkBaseView2(NULL);
    bbSetInputwxVtkBaseView3(NULL);
    bbSetInputwxVtkBaseView4(NULL);
    bbSetInputWithCtrlKey(false);
    bbSetOutputOut(-1);
    
    popupmenuinteractor=NULL;
    popupmenuinteractor2=NULL;
    popupmenuinteractor3=NULL;
    popupmenuinteractor4=NULL;
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxPopupMenu::bbUserInitializeProcessing()
{
//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxPopupMenu::bbUserFinalizeProcessing()
{
//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
}

}// EO namespace bbcreaMaracasVisu


